/* config_dialog.h
 *
 */
#include <gtk/gtk.h>

enum img_formats
{
	F_PNG = 0,
	F_JPEG,
	F_GIF,
	F_END
};

enum upload_protos
{
	UP_FTP = 0,
	UP_SCP,
	UP_END
};

struct config_dialog_imgopt
{
	GtkWidget *width;
	GtkWidget *height;
	GtkWidget *max_is_abs;
	GtkWidget *format;
	GtkWidget *format_items[F_END];
};

struct config_dialog
{
	GtkWidget *window;
	/* Global options */
	GtkWidget *url_prefix_entry;
	GtkWidget *thumb_prefix_entry;
	GtkWidget *preview_upd_int;
	/* Upload options */
	GtkWidget *upload_proto; /* option menu */
	GtkWidget *upload_proto_items[UP_END];
	GtkWidget *upload_user;
	GtkWidget *upload_pass;
	GtkWidget *upload_pass_label;
	GtkWidget *upload_host;
	GtkWidget *upload_path;
	/* Images options */
	struct config_dialog_imgopt image;
	struct config_dialog_imgopt thumb;
	/* Was the config saved? */
	gboolean saved;
};

gboolean show_config_dialog(GtkWindow * parent);
gboolean check_config (const char *config[]);
