#include <string.h>
#include <unistd.h> /* for close() */
#include <stdlib.h>
#include <glib.h>
#include "filename.h"

#define DEF_TEMP_DIR "/tmp"
#define TMPFILE_SUFFIX "-XXXXXX"
GString * tmp_dir;

const char * getfilename(const char *str)
{
	char * ret;

	ret = strrchr(str, '/');
	if (ret == NULL)
		return str;
	else
		return ret + 1;
}

void init_tmpdir(void)
{
	char * dir;

	dir = getenv("TMPDIR");
	if (dir == NULL)
		dir = DEF_TEMP_DIR;
	tmp_dir = g_string_new (dir);
}

void free_tmpdir(void)
{
	g_string_free(tmp_dir, TRUE);
}

const char * gettmpdir(void)
{
	return tmp_dir->str;
}

GString * new_temp_filename(const char * filename)
{
	GString * tmpf;

	tmpf = g_string_sized_new(128);
	g_string_printf(tmpf, "%s%s%s",
			tmp_dir->str, getfilename(filename),
			TMPFILE_SUFFIX);

	close(mkstemp(tmpf->str));
	return tmpf;
}

