/* $Id$
 *
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "preview.h"

void create_mainwin (struct imgsize * is, struct imgsize * ts,
		struct mainwin * win)
{
  GtkWidget *vbox1;
  GtkWidget *hbox8;
  GtkWidget *image4;
  GtkWidget *button_openfile;
  GtkWidget *hseparator2;
  GtkWidget *hbox10;
  GtkWidget *label_img_info_label;
  GtkWidget *hseparator4;
  GtkWidget *vbox2;
  GtkWidget *hbox7;
  GtkWidget *label9;
  GtkWidget *hbox3;
  GtkWidget *button1;
  GtkWidget *button_config;
  GtkWidget *ires;
  GtkWidget *tres;

  win->window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (win->window), _("Add an image"));

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (win->window), vbox1);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox8, TRUE, FALSE, 0);

  image4 = create_pixmap (win->window, NULL);
  gtk_widget_show (image4);
  gtk_box_pack_start (GTK_BOX (hbox8), image4, FALSE, FALSE, 2);

  win->label_filename = gtk_label_new ("");
  gtk_widget_show (win->label_filename);
  gtk_box_pack_start (GTK_BOX (hbox8), win->label_filename, TRUE, TRUE, 0);

  button_openfile = gtk_button_new_from_stock ("gtk-open");
  gtk_widget_show (button_openfile);
  gtk_box_pack_start (GTK_BOX (hbox8), button_openfile, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button_openfile), 3);

  hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (hseparator2);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator2, TRUE, TRUE, 0);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox10, FALSE, FALSE, 2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox10), 5);

  label_img_info_label = gtk_label_new (_("Info:"));
  gtk_widget_show (label_img_info_label);
  gtk_box_pack_start (GTK_BOX (hbox10), label_img_info_label, FALSE, FALSE, 2);
  gtk_label_set_justify (GTK_LABEL (label_img_info_label), GTK_JUSTIFY_LEFT);

  win->label_img_info = gtk_label_new (_("(image not loaded)"));
  gtk_widget_show (win->label_img_info);
  gtk_box_pack_start (GTK_BOX (hbox10), win->label_img_info, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (win->label_img_info), TRUE);
  gtk_label_set_justify (GTK_LABEL (win->label_img_info), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (win->label_img_info), TRUE);
  gtk_label_set_selectable (GTK_LABEL (win->label_img_info), TRUE);
  gtk_misc_set_alignment (GTK_MISC (win->label_img_info), 0, 0.5);

  win->button_preview = gtk_check_button_new_with_label(_("Preview"));
  gtk_widget_show (win->button_preview);
  gtk_box_pack_start (GTK_BOX (hbox10), win->button_preview,
		  FALSE, FALSE, 5);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_show (hseparator4);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator4, TRUE, TRUE, 0);

  win->frame_scale = gtk_frame_new (NULL);
  gtk_widget_show (win->frame_scale);
  gtk_box_pack_start (GTK_BOX (vbox1), win->frame_scale, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (win->frame_scale), 3);

  ires = create_image_resizer(is, NULL);
  gtk_widget_show (ires);
  gtk_container_add (GTK_CONTAINER (win->frame_scale), ires);

  win->checkbutton_scale = gtk_check_button_new_with_mnemonic (_("Scale down"));
  gtk_widget_show (win->checkbutton_scale);
  gtk_frame_set_label_widget (GTK_FRAME (win->frame_scale),
		  win->checkbutton_scale);
/*  gtk_container_set_border_width (GTK_CONTAINER (checkbutton_scale), 10); */

  win->frame_thumb = gtk_frame_new (NULL);
  gtk_widget_show (win->frame_thumb);
  gtk_box_pack_start (GTK_BOX (vbox1), win->frame_thumb, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (win->frame_thumb), 3);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (win->frame_thumb), vbox2);
  
  tres = create_image_resizer(ts, vbox2);
  gtk_widget_show (tres);
  gtk_box_pack_start (GTK_BOX (vbox2), tres, TRUE, TRUE, 0);

  win->checkbutton_newwin = gtk_check_button_new_with_mnemonic
	  (_("Open link in new window"));
  gtk_widget_show (win->checkbutton_newwin);
  gtk_box_pack_start (GTK_BOX (vbox2), win->checkbutton_newwin,
		  FALSE, FALSE, 4);
  
  win->checkbutton_thumb = gtk_check_button_new_with_mnemonic (_("Thumbnail"));
  gtk_widget_show (win->checkbutton_thumb);
  gtk_frame_set_label_widget (GTK_FRAME (win->frame_thumb),
		  win->checkbutton_thumb);
/*
  gtk_container_set_border_width (
		  GTK_CONTAINER (win->checkbutton_thumb), 10);
*/

  /* 'HTML options' frame */
  win->frame_htmlopt = gtk_frame_new (_("HTML options"));
  gtk_widget_show (win->frame_htmlopt);
  gtk_box_pack_start (GTK_BOX (vbox1), win->frame_htmlopt, TRUE, TRUE, 3);
  gtk_container_set_border_width (GTK_CONTAINER (win->frame_htmlopt), 3);

  hbox7 = gtk_hbox_new (FALSE, 3);
  gtk_widget_show (hbox7);
  gtk_container_add (GTK_CONTAINER (win->frame_htmlopt), hbox7);
  gtk_container_set_border_width (GTK_CONTAINER (hbox7), 6);

  label9 = gtk_label_new (_("IMG ALT="));
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (hbox7), label9, FALSE, FALSE, 2);
  GTK_WIDGET_SET_FLAGS (label9, GTK_CAN_FOCUS);
  gtk_label_set_justify (GTK_LABEL (label9), GTK_JUSTIFY_LEFT);

  win->entry_img_alt = gtk_entry_new ();
  gtk_widget_show (win->entry_img_alt);
  gtk_box_pack_start (GTK_BOX (hbox7), win->entry_img_alt, TRUE, TRUE, 0);

/*
  frame2 = gtk_frame_new (NULL);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (vbox1), frame2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 3);

  html_code = gtk_label_new (_("\n\n\n"));
  gtk_widget_show (html_code);
  gtk_container_add (GTK_CONTAINER (frame2), html_code);
  gtk_label_set_justify (GTK_LABEL (html_code), GTK_JUSTIFY_CENTER);
  gtk_label_set_line_wrap (GTK_LABEL (html_code), TRUE);
  gtk_label_set_selectable (GTK_LABEL (html_code), TRUE);
  gtk_misc_set_padding (GTK_MISC (html_code), 5, 5);

  label19 = gtk_label_new (_("HTML code preview"));
  gtk_widget_show (label19);
  gtk_frame_set_label_widget (GTK_FRAME (frame2), label19);
  gtk_label_set_justify (GTK_LABEL (label19), GTK_JUSTIFY_LEFT);
*/

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, FALSE, 0);

  button_config = gtk_button_new_from_stock ("gtk-preferences");
  gtk_widget_show (button_config);
  gtk_box_pack_start (GTK_BOX (hbox3), button_config, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button_config), 10);

  button1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (hbox3), button1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (button1), 10);

  win->button_ok = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (win->button_ok);
  gtk_box_pack_start (GTK_BOX (hbox3), win->button_ok, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (win->button_ok), 10);

	set_sensitive (win, FALSE);

	g_signal_connect ((gpointer) win->window, "delete_event",
			G_CALLBACK (gtk_main_quit), NULL);
	g_signal_connect ((gpointer) button_openfile, "clicked",
			G_CALLBACK (on_button_openfile_clicked), NULL);
	g_signal_connect ((gpointer) win->checkbutton_scale, "toggled",
			G_CALLBACK (on_checkbutton_scale_toggled), NULL);
	g_signal_connect ((gpointer) win->checkbutton_thumb, "toggled",
			G_CALLBACK (on_checkbutton_thumb_toggled), NULL);
	g_signal_connect ((gpointer) win->checkbutton_newwin, "toggled",
			G_CALLBACK (on_checkbutton_newwin_toggled), NULL);
	g_signal_connect ((gpointer) button_config, "clicked",
			G_CALLBACK (on_button_config_clicked), NULL);
	g_signal_connect ((gpointer) button1, "clicked",
			G_CALLBACK (gtk_main_quit), NULL);
	g_signal_connect ((gpointer) win->button_ok, "clicked",
			G_CALLBACK (on_button_ok_clicked), NULL);
	g_signal_connect ((gpointer) is->slider, "value_changed",
			G_CALLBACK (tscale_callback), (gpointer) ts);

	connect_preview_buttons (win->button_preview, is->preview, ts->preview);
}

void set_sensitive(struct mainwin * win, gboolean sens)
{
	gtk_widget_set_sensitive(win->label_img_info, sens);
	gtk_widget_set_sensitive(win->button_preview, sens);
	gtk_widget_set_sensitive(win->frame_scale, sens);
	gtk_widget_set_sensitive(win->frame_thumb, sens);
	gtk_widget_set_sensitive(win->frame_htmlopt, sens);
	gtk_widget_set_sensitive(win->button_ok, sens);
}

GtkWidget*
create_fileselection1 (void)
{
  GtkWidget *fileselection1;
  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;

  fileselection1 = gtk_file_selection_new (_("Select File"));
  gtk_container_set_border_width (GTK_CONTAINER (fileselection1), 10);
  gtk_window_set_modal (GTK_WINDOW (fileselection1), TRUE);
  gtk_file_selection_hide_fileop_buttons (GTK_FILE_SELECTION (fileselection1));

  ok_button1 = GTK_FILE_SELECTION (fileselection1)->ok_button;
  gtk_widget_show (ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

  cancel_button1 = GTK_FILE_SELECTION (fileselection1)->cancel_button;
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);

  g_signal_connect_swapped ((gpointer) ok_button1, "clicked",
                            G_CALLBACK (store_filename),
                            GTK_OBJECT (fileselection1));
  g_signal_connect_swapped ((gpointer) cancel_button1, "clicked",
                            G_CALLBACK (gtk_widget_destroy),
                            GTK_OBJECT (fileselection1));

  return fileselection1;
}
