/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#ifdef MTRACE
#include <mcheck.h>
#endif

#include "htmlgen.h"
#include "config_file.h"
#include "config_dialog.h"
#include "filename.h"
#include "interface.h"
#include "support.h"
#include "callbacks.h"
#include "preview.h"

struct mainwin win;
struct imgsize is;
struct imgsize ts;
struct html_data hd;
extern char * config[C_END];


int main (int argc, char *argv[])
{
#ifdef MTRACE
	mtrace();
#endif

#ifdef ENABLE_NLS
	bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
#endif

	gtk_set_locale ();
	gtk_init (&argc, &argv);

	/* we don't have any pixmaps so far
	add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");
	*/
	init_tmpdir();
	init_preview(&is, &ts);
	init_config();
	read_config(config);
	if (set_config_defaults(config) > 0)
		/* Some options were not set and is auto-set now,
		 * so let's show config dialog to user.
		 */
		if (show_config_dialog(NULL) == FALSE)
			/* User clicked "Cancel", so we cancel now */
			return 0;


	create_mainwin (&is, &ts, &win);

	if (argc > 1)
		if (load_image(argv[1]) == FALSE)
			return 1;
  
	gtk_widget_show (win.window);

	gtk_main ();
	free_tmpdir();
	return 0;
}

