/* preview.h
 */
#include "imgsize.h"

struct preview_window
{
	/* Preview window */
	GtkWindow * w;
	/* Window title */
	const char * title;
	/* Widget for displaying image */
	GtkImage * image;
	/* Original pixbuf loaded from file */
	GdkPixbuf * orig_pb;
	/* Pixbuf used for displaying image - can be equal to orig_pb */
	GdkPixbuf * pb;
	/* Pointer to toggle button used for preview activation */
	GtkWidget * button;
	/* periodical event handler */
	guint teh;
	/* size of last converted image */
	int x;
	int y;
	/* link to structure containing preview size etc. */
	const struct imgsize * is;
};

void init_preview (struct imgsize * is, struct imgsize * ts);
int set_preview_file (const char * filename);
void connect_preview_buttons (GtkWidget * b1, GtkWidget * b2, GtkWidget * b3);
